Schema (Java SE 26 & JDK 26)
Description: declaration: module: java.xml, package: javax.xml.validation, class: Schema
Keywords: javax.xml.validation.Schema class

# Class Schema

java.lang.Object
javax.xml.validation.Schema

public abstract class Schema extends Object
Immutable in-memory representation of grammar.

This object represents a set of constraints that can be checked/ enforced against an XML document.

A `Schema` object is thread safe and applications are encouraged to share it across many parsers in many threads.

A `Schema` object is immutable in the sense that it shouldn't change the set of constraints once it is created. In other words, if an application validates the same document twice against the same `Schema`, it must always produce the same result.

A `Schema` object is usually created from `SchemaFactory`.

Two kinds of validators can be created from a `Schema` object. One is `Validator`, which provides highly-level validation operations that cover typical use cases. The other is `ValidatorHandler`, which works on top of SAX for better modularity.

This specification does not refine the `Object.equals(java.lang.Object)` method. In other words, if you parse the same schema twice, you may still get `!schemaA.equals(schemaB)`.

Since:
  1.5
See Also:
  - XML Schema Part 1: Structures
  - Extensible Markup Language (XML) 1.1
  - Extensible Markup Language (XML) 1.0 (Second Edition)

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `Schema()`
  Constructor for the derived class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract Validator`
  `newValidator()`
  Creates a new `Validator` for this `Schema`.
  `abstract ValidatorHandler`
  `newValidatorHandler()`
  Creates a new `ValidatorHandler` for this `Schema`.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### Schema

    protected Schema()
    Constructor for the derived class.

    The constructor does nothing.

- ## Method Details

  - ### newValidator

    public abstract Validator newValidator()
    Creates a new `Validator` for this `Schema`.

    A validator enforces/checks the set of constraints this object represents.

    Implementors should assure that the properties set on the `SchemaFactory` that created this `Schema` are also set on the `Validator` constructed.

    Returns:
      Always return a non-null valid object.

  - ### newValidatorHandler

    public abstract ValidatorHandler newValidatorHandler()
    Creates a new `ValidatorHandler` for this `Schema`.

    Implementors should assure that the properties set on the `SchemaFactory` that created this `Schema` are also set on the `ValidatorHandler` constructed.

    Returns:
      Always return a non-null valid object.